/**
 * 初始化获取配置文件
 */

const http = require('http');
const fs = require('fs');
const path = require('path');


function Request(options, send, callback) {
    let data = [];
    let req = http.request(options, function(res) {

        res.on('data', function(d) {
            data.push(d);
        });
        res.on('end', function() {
            data = Buffer.concat(data).toString();

            let result = {};
            try {
                result = JSON.parse(data);
            } catch ( e ) {
                // log.debug('ERROR: -mHttpService- json parse error');
                // req.abort();
                return callback({
                    error: "HttpService- server json parse error!" + e
                });
            }

            // req.abort();
            return callback({
                data: result
            });
        });
    });

    if ('POST' == options.method) {
        req.end(JSON.stringify(send));
    } else {
        req.end();
    }

    req.on('error', function(e) {
        req.abort();
        return callback({
            error: e
        });
    });
}

/**
 * [url is: http://127.0.0.1:6060/configuration?sys=Ssp]
 */
exports.Config = (filename, url, dir, callback) => {
    let methodapath = url.split('//');
    let hostapp = methodapath[1].split('/');
    let hostap = hostapp[0].split(':');

    let options = {
        hostname: hostap[0],
        port: hostap[1] || 80,
        method: 'GET',
        path: '/' + hostapp[1] || '',
        headers: {
            "Content-Type": "application/json",
        }
    }

    Request(options, null, (res) => {
        if ((!res.error) && (res.data)) {
            let data = res.data;
            let pay = JSON.parse(data.data);
            delete data.data;
            delete pay.time;
            delete pay.Time;

            change = {};
            for (let key in pay) {
                if (!(/[A-Z]/.test(key))) {
                    change[key] = "";
                }
            }

            data.Host = 'http://' + options.hostname + '/track';
            data.System = options.path.split('sys=')[1];
            data.data = change;

            fs.writeFile(path.join(dir, '/', filename), JSON.stringify(data), function(err) {
                if (err) {
                    console.log('configuration write error ', err, JSON.stringify(data))
                    callback({
                        error: err
                    });
                } else {
                    // console.log('configuration success', new Date())
                    callback({
                        data: data
                    });
                }
            });
        } else {
            callback(res.error || res.data);
        }
    });
}
